<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/17/2004 *
 * ================                             Last change: 09/17/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : optimize_functions.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Optimize functions                               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Optimize-Funktionen                              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
// Part taken from admin optimize module of PHPNuke (http://www.phpnuke.org)
//
function REPAIR_OPTIMIZE_DB()
{
	global $MySQL;
	$ret = array();
	$tot_data = 0; $tabs = 0; $opts = 0;
	$tot_idx = 0; $total_gain = 0;
	$tot_all = 0;
	$result = @SQL_QUERY("SHOW TABLE STATUS FROM ".$MySQL['dbase'], __FILE__, __LINE__);
	$tabs = @SQL_NUMROWS($result);
	$ret['total_size'] = 0;
	$ret['total_tabs'] = $tabs;
	if ($tabs > 0)
	{
		while ($row = SQL_FETCHARRAY($result))
		{
			$tot_data = $row['Data_length'];
			$tot_idx  = $row['Index_length'];
			$total = $tot_data + $tot_idx;
			$total = $total / 1024;
			$total = round ($total, 3);
			$gain  = $row['Data_free'];
			$gain  = $gain / 1024;
			$total_gain += $gain;
			$gain = round ($gain, 3);

			// Repair table
			$result1 = SQL_QUERY("REPAIR TABLE ".$row['Name'], __FILE__, __LINE__);
			$rep = SQL_FETCHARRAY($result1);

			// Optimize table
			$result1 = SQL_QUERY("OPTIMIZE TABLE ".$row['Name'], __FILE__, __LINE__);
			$opt = SQL_FETCHARRAY($result1);

			// Add data to array
			$ret['tables'][] = array($row['Name'], $opt['Msg_text'], $rep['Msg_text'], $total, $gain);

			// Count total table data
			$ret['total_size'] += $total;
		}
	}
	// Total optimized data
	$total_gain = round ($total_gain,3);
	$ret['total_gain'] = $total_gain;

	// Insert new row
	$result = SQL_QUERY("INSERT INTO "._MYSQL_PREFIX."_optimize_gain (gain) VALUES ('".$total_gain."')", __FILE__, __LINE__);

	// Get total runs and total optimization count
	$result = SQL_QUERY("SELECT COUNT(id) AS rows, SUM(gain) AS opti FROM "._MYSQL_PREFIX."_optimize_gain", __FILE__, __LINE__);
	list($total_rows, $total_opti) = SQL_FETCHROW($result);

	// Free memory
	SQL_FREERESULT($result);

	// Transfer data
	$ret['total_rows'] = $total_rows;
	$ret['total_opti'] = $total_opti;

	// Return array
	return $ret;
}
//
?>
